﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.IO

Public Class Form1

    Dim VesselLayerGood As MsSql2008FeatureLayer ' will we get the points directly from MSSQL?
    Dim VesselLayerBad As MsSql2008FeatureLayer ' will we get the points directly from MSSQL?
    Dim dynamicOverlayGood As New LayerOverlay() ' vessel points
    Dim dynamicOverlayBad As New LayerOverlay() ' vessel points
    Dim rotatedImageStyle As New RotatedImageStyle(New GeoImage(Path.GetDirectoryName(Application.ExecutablePath) & "\GreenShipIcon.png"), "VCMG")
    Dim proj4 As New Proj4Projection()

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        Dim ConnectionString As String = "Data Source=DEVELOPMENT01\SQLEXPRESS;Initial Catalog=MVMSuite;Integrated Security=True;Connection Timeout=0"

        VesselLayerGood = New MsSql2008FeatureLayer(ConnectionString, "tmpTest1Vessels", "ID")
        VesselLayerBad = New MsSql2008FeatureLayer(ConnectionString, "tmpTest2Vessels", "ID")

    End Sub

    Private Sub Form1_Shown(sender As Object, e As System.EventArgs) Handles Me.Shown

        MapOne.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255))
        MapTwo.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255))

        proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326)
        proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString()

        VesselLayerGood.FeatureSource.Projection = proj4
        dynamicOverlayGood.Layers.Add("vesselLayer", VesselLayerGood)
        MapOne.Overlays.Add("dynamicOverlay", dynamicOverlayGood)
        VesselLayerGood.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear()
        VesselLayerGood.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(rotatedImageStyle)
        VesselLayerGood.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        VesselLayerGood.Open()
        Dim mapOutlineGood As New ThinkGeo.MapSuite.Core.RectangleShape
        Try
            mapOutlineGood = VesselLayerGood.GetBoundingBox ' we get stuck on this line sometimes - Asia Marine for example. Bounding box too big?
        Catch
        End Try
        MapOne.CurrentExtent = mapOutlineGood
        txtMapOneFeatureCount.Text = "VesselLayerGood.FeatureSource.GetCount=" & VesselLayerGood.FeatureSource.GetCount
        VesselLayerGood.Close()
        MapOne.ZoomOut(50)
        MapOne.Refresh()

        VesselLayerBad.FeatureSource.Projection = proj4
        dynamicOverlayBad.Layers.Add("vesselLayer", VesselLayerBad)
        MapTwo.Overlays.Add("dynamicOverlay", dynamicOverlayBad)
        VesselLayerBad.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear()
        VesselLayerBad.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(rotatedImageStyle)
        VesselLayerBad.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        VesselLayerBad.Open()
        Dim mapOutline As New ThinkGeo.MapSuite.Core.RectangleShape
        Try
            mapOutline = VesselLayerBad.GetBoundingBox ' we get stuck on this line sometimes - Asia Marine for example. Bounding box too big?
        Catch
        End Try
        MapTwo.CurrentExtent = mapOutline
        txtMapTwoFeatureCount.Text = "VesselLayerBad.FeatureSource.GetCount=" & VesselLayerBad.FeatureSource.GetCount
        VesselLayerBad.Close()
        MapTwo.ZoomOut(50)
        MapTwo.Refresh()

        Debug.Print("Done")

    End Sub
End Class
