﻿Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.Linq
Imports System.Text
Imports ThinkGeo.MapSuite.Core

'Namespace RotatedImageStyle
Public Class RotatedImageStyle
    Inherits Style
    Private m_geoImage As GeoImage
    Private m_angleColumnName As String

    Public Sub New()

        Me.New(New GeoImage(), String.Empty)

    End Sub

    Public Sub New(ByVal geoImage As GeoImage, ByVal angleColumnName As String)

        Me.m_geoImage = geoImage
        Me.m_angleColumnName = angleColumnName

    End Sub

    Public Property GeoImage() As GeoImage

        Get
            Return m_geoImage
        End Get

        Set(ByVal value As GeoImage)
            GeoImage = value
        End Set

    End Property

    Public Property AngleColumnName() As String

        Get
            Return m_angleColumnName
        End Get

        Set(ByVal value As String)
            AngleColumnName = value
        End Set

    End Property

    Protected Overrides Sub DrawCore(ByVal features As IEnumerable(Of Feature), ByVal canvas As GeoCanvas, ByVal labelsInThisLayer As Collection(Of SimpleCandidate), ByVal labelsInAllLayers As Collection(Of SimpleCandidate))

        'Debug.Print(Now & " Sub DrawCore started")
        For Each feature As Feature In features
            'Dim angleData As Single = Convert.ToSingle(feature.ColumnValues(m_angleColumnName))
            Dim angleData As Single = Convert.ToSingle(IIf(feature.ColumnValues(m_angleColumnName) <> "", feature.ColumnValues(m_angleColumnName), 0))
            Dim pointShape As PointShape = DirectCast(feature.GetShape(), PointShape)
            'angleData);
            canvas.DrawWorldImageWithoutScaling(m_geoImage, pointShape.X, pointShape.Y, DrawingLevel.LevelFour, 0, 0, _
             360 - angleData)
        Next
        'Debug.Print(Now & " Sub DrawCore ended")

    End Sub

    Protected Overrides Function GetRequiredColumnNamesCore() As Collection(Of String)

        Dim columns As New Collection(Of String)()
        If Not columns.Contains(m_angleColumnName) Then
            columns.Add(m_angleColumnName)
        End If
        Return columns

    End Function

End Class
